Bug 1441728 - Review Request: cld2 - Compact Language Detector 2
Summary: Review Request: cld2 - Compact Language Detector 2
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Kalev Lember
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-04-12 14:52 UTC by c72578
Modified: 2017-08-28 16:19 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-08-27 06:23:20 UTC
Type: ---
klember: fedora-review+


Attachments (Terms of Use)

Description c72578 2017-04-12 14:52:33 UTC
Spec URL: http://copr-dist-git.fedorainfracloud.org/cgit/c72578/cld2/cld2.git/plain/cld2.spec?h=f25&id=484125d9b39fe9f51009a22655dfd6bb9501500e
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/c72578/cld2/fedora-25-x86_64/00538918-cld2/cld2-0.0.0-0.1.gitb56fa78.fc25.src.rpm
Description:
Compact Language Detector 2 (CLD2, https://github.com/CLD2Owners/cld2) is a requirement for Poedit in order to enable language detection.
A Fedora copr repo has been created here for packaging and building tests:
https://copr.fedorainfracloud.org/coprs/c72578/cld2/

Fedora Account System Username: c72578

Comment 5 c72578 2017-04-25 11:25:53 UTC
Spec URL: http://copr-dist-git.fedorainfracloud.org/cgit/c72578/cld2/cld2.git/plain/cld2.spec?h=f25

Please help with the Spec URL.
When using "fedora-review -b 1441728" I am getting:

ERROR: 'Error 404 downloading http://copr-dist-git.fedorainfracloud.org/cgit/c72578/cld2/cld2.git/tree/cld2.spec'

Comment 6 c72578 2017-04-25 14:17:07 UTC
Spec URL: https://raw.githubusercontent.com/c72578/rpmbuild/master/SPECS/cld2.spec

Moved spec file to github repo because of issues with linking to spec file on Fedora copr.

Comment 7 c72578 2017-05-03 11:53:53 UTC
Spec URL: https://raw.githubusercontent.com/c72578/rpmbuild/master/SPECS/cld2.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/c72578/cld2/fedora-25-x86_64/00546244-cld2/cld2-0.0.0-0.2.gitb56fa78.fc25.src.rpm

* Wed May 03 2017 Wolfgang Stöggl <c72578@yahoo.de> - 0.0.0-0.2.gitb56fa78
- Modifications to spec file
- Remove sub-package libcld2. Names for rpms are cld2 and cld2-devel now
- Updated version of CMakeLists.txt

Comment 8 c72578 2017-05-03 14:24:46 UTC
Spec URL: https://raw.githubusercontent.com/c72578/rpmbuild/master/SPECS/cld2.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/c72578/cld2/fedora-25-x86_64/00546449-cld2/cld2-0.0.0-0.3.gitb56fa78.fc25.src.rpm

* Wed May 03 2017 Wolfgang Stöggl <c72578@yahoo.de> - 0.0.0-0.3.gitb56fa78
- Fix unused-direct-shlib-dependency reported by rpmlint (installed packages)
- Update CMakeLists.txt to version 0.0.198, to avoid 
  shared-lib-without-dependency-information of libcld2_full

Comment 9 c72578 2017-05-05 11:22:54 UTC
Spec URL: https://raw.githubusercontent.com/c72578/rpmbuild/master/SPECS/cld2.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/c72578/cld2/fedora-25-x86_64/00547467-cld2/cld2-0.0.0-0.4.gitb56fa78.fc25.src.rpm

* Fri May 05 2017 Wolfgang Stöggl <c72578@yahoo.de> - 0.0.0-0.4.gitb56fa78
- Simplify cmake, use cmake macro

Comment 10 c72578 2017-05-05 13:44:38 UTC
- Link to successful Koji build:
https://koji.fedoraproject.org/koji/taskinfo?taskID=19410918

Comment 11 c72578 2017-05-24 13:53:33 UTC
Spec URL: https://raw.githubusercontent.com/c72578/rpmbuild/master/SPECS/cld2.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/c72578/cld2/fedora-rawhide-x86_64/00556214-cld2/cld2-0.0.0-0.5.gitb56fa78.fc27.src.rpm

* Wed May 24 2017 Wolfgang Stöggl <c72578@yahoo.de> - 0.0.0-0.5.gitb56fa78
- Use license macro for LICENSE
- Add doc README.md

Comment 12 Jan Kalina 2017-06-02 14:15:32 UTC
Informal (UNOFFICIAL) Package Review
====================================
I dont think it is fedora requirement, but I would recommend to tag
library version in git before packaging - version "0.0.0" in RPM looks
weird and you can use readable git tag name instead of commit hash.

As automated tests are included in source package, their run SHOULD
be also included in %check section.

Not sure, but I also think hidden ".build-id" directory should not be
included in package.

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Issues:
=======
- All build dependencies are listed in BuildRequires, except for any that
  are listed in the exceptions section of Packaging Guidelines.
  Note: These BR are not needed: gcc-c++
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "Unknown or generated", "*No copyright* Apache
     (v2.0)". 25 files have unknown license. Detailed output of
     licensecheck in /home/jkalina/review-cld2/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/lib/.build-id(ddcutil)
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 747520 bytes in 12 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     cld2-debuginfo
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: cld2-0.0.0-0.5.gitb56fa78.fc27.x86_64.rpm
          cld2-devel-0.0.0-0.5.gitb56fa78.fc27.x86_64.rpm
          cld2-debuginfo-0.0.0-0.5.gitb56fa78.fc27.x86_64.rpm
          cld2-0.0.0-0.5.gitb56fa78.fc27.src.rpm
cld2.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
cld2.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
cld2-devel.x86_64: W: only-non-binary-in-usr-lib
4 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (debuginfo)
-------------------
Checking: cld2-debuginfo-0.0.0-0.5.gitb56fa78.fc27.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
cld2-devel.x86_64: W: only-non-binary-in-usr-lib
cld2.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
cld2.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
3 packages and 0 specfiles checked; 0 errors, 3 warnings.



Requires
--------
cld2-debuginfo (rpmlib, GLIBC filtered):

cld2-devel (rpmlib, GLIBC filtered):
    cld2(x86-64)
    libcld2.so.0()(64bit)
    libcld2_dynamic.so.0()(64bit)
    libcld2_full.so.0()(64bit)

cld2 (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)



Provides
--------
cld2-debuginfo:
    cld2-debuginfo
    cld2-debuginfo(x86-64)

cld2-devel:
    cld2-devel
    cld2-devel(x86-64)

cld2:
    cld2
    cld2(x86-64)
    libcld2.so.0()(64bit)
    libcld2_dynamic.so.0()(64bit)
    libcld2_full.so.0()(64bit)



Source checksums
----------------
https://github.com/CLD2Owners/cld2/archive/b56fa78a2fe44ac2851bae5bf4f4693a0644da7b.tar.gz#/cld2-b56fa78.tar.gz :
  CHECKSUM(SHA256) this package     : 2bd0f8aa344698c0ce6b2c89f5540af10e69e92d4c74f9fe66ffe25281be1111
  CHECKSUM(SHA256) upstream package : 2bd0f8aa344698c0ce6b2c89f5540af10e69e92d4c74f9fe66ffe25281be1111
https://raw.githubusercontent.com/c72578/rpmbuild/master/SOURCES/CMakeLists.txt :
  CHECKSUM(SHA256) this package     : 559a7fa47f4762204c7fe5e070e6a425fc38b1f2b3111cd63f9b70d4137e1a49
  CHECKSUM(SHA256) upstream package : 559a7fa47f4762204c7fe5e070e6a425fc38b1f2b3111cd63f9b70d4137e1a49


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -u https://bugzilla.redhat.com/show_bug.cgi?id=1441728
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 13 c72578 2017-06-02 16:03:23 UTC
Dear Jan,
thank you very much for your valuable feedback and the review.

The spec file has been updated according to your suggestions:

* Fri Jun 02 2017 Wolfgang Stöggl <c72578@yahoo.de> - 0.0.0-0.6.gitb56fa78
- Removed BR: gcc-c++
- Added check section and tests

Concerning the hidden ".build-id", I found the following:
https://bugzilla.redhat.com/show_bug.cgi?id=1431408

Versioning or tag library version in git before packaging seems to be a challenge. Upstream is "difficult" to reach and "not too active". Any advice how to handle the versioning alternatively?

Spec URL: https://raw.githubusercontent.com/c72578/rpmbuild/master/SPECS/cld2.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/c72578/cld2/fedora-rawhide-x86_64/00560950-cld2/cld2-0.0.0-0.6.gitb56fa78.fc27.src.rpm

Comment 14 Jan Kalina 2017-06-02 22:02:16 UTC
Thanks for update!
If you are not owner of upstream repo, please ignore my note about tagging - in such case is using git hash to identity version OK. Just note that we have following guidelines for snapshot versions packaging:

- When upstream has never chosen a version, you MUST use "Version: 0".
- All snapshots MUST contain a snapshot information field in the Release: tag. That field must at minimum consist of the date in eight-digit "YYYYMMDD" format. The packager MAY include up to 17 characters of additional information after the date. The following formats are suggested:

    YYYYMMDD.<revision>
    YYYYMMDD<scm><revision> 

see https://fedoraproject.org/wiki/Packaging:Versioning

Comment 15 c72578 2017-06-04 04:56:02 UTC
Thank you very much for your information on versioning of the package.
The spec file has been updated according to your suggestions:

Update cld2.spec file 0-0.7.20150821gitb56fa78

* Sun Jun 04 2017 Wolfgang Stöggl <c72578@yahoo.de> - 0-0.7.20150821gitb56fa78
- Change version of package from 0.0.0 to 0
- Added date of git commit to <snapinfo>

Spec URL: https://raw.githubusercontent.com/c72578/rpmbuild/master/SPECS/cld2.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/c72578/cld2/fedora-rawhide-x86_64/00561204-cld2/cld2-0-0.7.20150821gitb56fa78.fc27.src.rpm

Comment 16 Jan Kalina 2017-06-05 09:08:52 UTC
Thanks! I dont see any other problem. Lets see what official sponsor will find... ;)

Comment 17 c72578 2017-07-31 07:13:29 UTC
Dear Jan,
thank you very much for your review.
In the meantime I have been sponsored into the packager group.
Best regards
Wolfgang

Comment 18 Kalev Lember 2017-08-10 11:25:20 UTC
Packaging looks nice and clean to me. Approving based on Jan Kalina's unofficial review above.

I'd maybe change two minor things, one is that

%if 0%{?usesnapshot}
    %autosetup -n %name-%{commit0}
%else
    %setup -q
%endif

... seems a bit unsymmetrical; would be easier to read if both were %autosetup (or both were %setup -q) but not a mix like this.

The other minor thing is that -devel package doesn't need to contain '%license LICENSE' since it's already included in the base package.

Feel free to change these if you want after importing. APPROVED

Comment 19 Gwyn Ciesla 2017-08-10 17:42:02 UTC
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/cld2

Comment 20 Gwyn Ciesla 2017-08-10 17:42:10 UTC
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/cld2

Comment 21 c72578 2017-08-11 07:38:20 UTC
Dear Kalev,
Thank you very much for your valuable feedback and approving the package.
The spec file has been updated according to your suggestions before the package import:

Spec URL: https://raw.githubusercontent.com/c72578/rpmbuild/9b1104c45f774ef6ad466cf5f2ddd281148fbb2d/SPECS/cld2.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/c72578/cld2/fedora-rawhide-x86_64/00589052-cld2/cld2-0-0.8.20150821gitb56fa78.fc27.src.rpm

Comment 22 Fedora Update System 2017-08-17 11:16:00 UTC
cld2-0-0.9.20150821gitb56fa78.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-eda10926f3

Comment 23 Fedora Update System 2017-08-18 21:54:18 UTC
cld2-0-0.9.20150821gitb56fa78.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-e803b2d329

Comment 24 Fedora Update System 2017-08-19 18:55:06 UTC
cld2-0-0.9.20150821gitb56fa78.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-eda10926f3

Comment 25 Fedora Update System 2017-08-27 06:23:20 UTC
cld2-0-0.9.20150821gitb56fa78.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 26 Fedora Update System 2017-08-28 16:19:31 UTC
cld2-0-0.9.20150821gitb56fa78.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.